/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package incomingcall;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;

/**
 *
 * @author user
 */
public class IncomingCall{

    /**
     * @param args the command line arguments
     */
    
    public static void main(String[] args) throws IOException{
        try (ServerSocket listener = new ServerSocket(7784)) {
            while (true) {
                try (Socket socket = listener.accept()) {
                    String inputResponse = GetResponse(socket.getInputStream());
                    String caller = GetValue(inputResponse, "Caller");
                    
                    System.out.println("Incoming call from " + caller);
                    
                    String outputResponse = "<Response>\r\n" +
                                            "	<Delay>1</Delay>\r\n" +
                                            "	<Speak>Congratulations, this is your first OZML Response command.</Speak>\r\n" +
                                            "	<Delay>1</Delay>\r\n" +
                                            "	<Speak>For more information on OZML syntax, visit www.ozekiphone.com </Speak>\r\n" +
                                            "</Response>";
                     
                    OutputStream outputStream = socket.getOutputStream();
                    outputStream.write(CreateHttpResponse(outputResponse).getBytes());
                    outputStream.flush();
                    
                    socket.close();
                }
            }
        } catch (Exception ex)
        {
            System.out.println(ex.getMessage());
        }
    }
    
    private static String CreateHttpResponse(String pContent) {
        String header = "HTTP/1.0 200 OK\r\n"
                + "Content-Type: text/xml\r\n"
                + "Connection: Keep-Alive\r\n"
                + "Keep-Alive: timeout=15, max=100\r\n\r\n";

        StringBuilder response = new StringBuilder();

        response.append(header);
        response.append(pContent);

        return new String(response);
    }
    
    private static String GetResponse(InputStream pInputStream) throws IOException {
        byte[] b = new byte[pInputStream.available()];
        pInputStream.read(b);

        return new String(b);
    }

    private static String GetValue(String pContent, String pInfoName) {
        String value;

        int beginIndex = pContent.indexOf(pInfoName);
        int endIndex = pContent.indexOf("&", beginIndex);

        value = pContent.substring(beginIndex, endIndex).split("=")[1];

        return value;
    }
}
