/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 *
 */

package sendsms;

import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Scanner;

/**
 *
 * @author user
 */
public class SendSMS {

    /**
     * @param args the command line arguments
     */
    static String serverUrl = "";
    
    static String[] Commands = new String[6];
    static String[] CommandParameters = new String[6];
    
    public static void main(String[] args) {
        ShowGreetingMessage();
        InitializeCommands();
        
        CommandParameters[0] = "SendSms";       
        ReadParameters();
        
        try
        {
            URL url = new URL(CreateUrl(serverUrl, Commands, CommandParameters));
            HttpURLConnection connection = (HttpURLConnection)url.openConnection();
            connection.setRequestMethod("GET");
            connection.connect();
            
            connection.disconnect();
        } catch (Exception e)
        {
            System.out.println(e.getMessage());
        }
    }
    
    private static void ShowGreetingMessage()
    {
        System.out.println("This is a simple Ozeki Phone System XE demo written in Java.");
        System.out.println("It can be used to setup calls, send sms's and receive");
        System.out.println("corresponding delivery reports.");
        System.out.println("The source code of this demo can be downloaded from: ");
        System.out.println("link");
        System.out.println("-------------------------------------------------------------------------------");
    }
    
    private static void InitializeCommands()
    {
        Commands[0] = "Command";
        Commands[1] = "ApiExtension";
        Commands[2] = "Sender";
        Commands[3] = "Recipient";
        Commands[4] = "Message";
        Commands[5] = "DeliveryReportURL";
    }
    
    private static void ReadParameters()
    {
        serverUrl = Read("Server URL(default: http://http://192.168.115.175:7780/)", false);
        if (serverUrl != null && serverUrl.equals(""))
            serverUrl = "http://192.168.115.175:7780/";
        
        CommandParameters[1] = Read("Api extension(default: 9999)", false);
        if (CommandParameters[1] != null && CommandParameters[1].equals(""))
            CommandParameters[1] = "9999";
        
        CommandParameters[2] = Read("Sender(deafult: 9999)", false);
        if (CommandParameters[2] != null && CommandParameters[2].equals(""))
            CommandParameters[2] = "9999";
        
        CommandParameters[3] = Read("Recipient", true);
        CommandParameters[4] = Read("Message", true);
        CommandParameters[5] = Read("Delivery report URL", false);
    }
    
    private static String Read(String inputName, boolean readWhileEmpty)
    {
        String input;
        Scanner scannner = new Scanner(System.in);
        
        System.out.print(inputName + ": ");
        while (true)
        {
            input = scannner.nextLine();
            
            if (!readWhileEmpty)
                return input;
            
            if (input != null && !input.equals(""))
                return input;
            
            System.out.println(inputName + " cannot be empty.");
            System.out.print(inputName + ": ");
        }
    }
    
    private static String CreateUrl(String pServerUrl ,String[] pCommands, String[] pCommandsValues)
    {
        String url = pServerUrl;
        
        if (url.charAt(url.length() - 1) != '/')
            url+='/';
        
        url += '?' + pCommands[0] + '=' + pCommandsValues[0];
        
        for (int i = 1; i <= pCommands.length - 1; i++) {
            url += '&' + pCommands[i] + '=' + pCommandsValues[i].replace(' ', '+');
        }
                
        return url;
    }
}
